Name: freemind		
Version: 0.9.0
Release:	13%{?dist}
Summary:	Free mind mapping software	

Group:	Applications/Productivity
License: GPLv2 and MIT
URL:	http://freemind.sourceforge.net	
Source0:	http://downloads.sourceforge.net/%{name}/%{name}-src-0.9.0.tar.gz
Source1:	freemind.desktop
Source2:	freemind.xml
Source3:	freemind.sh
Patch0:		freemind-0.9.0-svg-build.patch
Patch1:		freemind-0.9.0-manifest.patch
Patch2:		freemind-0.9.0-javadoc.patch
Patch3:		freemind-0.9.0-jgoodies-build.patch
Patch4:		freemind-0.9.0-jgoodies-forms-1_6.patch

BuildRoot:	%(mktemp -ud %{_tmppath}/%{name}-%{version}-%{release}-XXXXXX)
BuildArch: noarch
BuildRequires:	ant
BuildRequires:	ant-nodeps
BuildRequires:	ant-trax
BuildRequires:	ant-apache-regexp
BuildRequires:	avalon-framework
BuildRequires:	batik
BuildRequires:	batik-squiggle
BuildRequires:	bcel
BuildRequires:	desktop-file-utils
BuildRequires:	fop
BuildRequires:	groovy
BuildRequires:	ImageMagick
BuildRequires:	jakarta-oro
BuildRequires:	apache-commons-lang
BuildRequires:	jarbundler
BuildRequires:	java >= 1:1.6.0
BuildRequires:	javahelp2
BuildRequires:	java-devel 
BuildRequires:	ws-jaxme 
BuildRequires:	jgoodies-forms >= 1.6.0
BuildRequires:	jpackage-utils
BuildRequires:	jibx
BuildRequires:	junit
BuildRequires:	log4j
BuildRequires:	SimplyHTML
BuildRequires:	xpp3


Requires:	apache-commons-lang
Requires:	batik
Requires:	batik-squiggle
Requires:	desktop-file-utils
Requires:	fop
Requires:	groovy
Requires:	hicolor-icon-theme
Requires:	jakarta-oro
Requires:	java
Requires:	javahelp2
Requires:	jgoodies-forms
Requires:	jgoodies-looks
Requires:	jibx
Requires:	jpackage-utils
Requires:	SimplyHTML
Requires:	xpp3

%description
FreeMind is a premier free mind-mapping software written in Java. The 
recent development has hopefully turned it into high productivity tool. 
So you want to write a completely new metaphysics? Why don't you use 
FreeMind? You have a tool at hand that remarkably resembles the tray 
slips of Robert Pirsig, described in his sequel to Zen and the Art of 
Motorcycle Maintenance called Lila. Do you want to refactor your essays 
in a similar way you would refactor software? Or do you want to keep 
personal knowledge base, which is easy to manage? Why don't you try 
FreeMind? Do you want to prioritize, know where you are, where you've 
been and where you are heading, as Stephen Covey would advise you? Have 
you tried FreeMind to keep track of all the things that are needed for 
that?

%package javadoc
Summary:	API documentation for %{name}
Group:	Documentation
Requires:	%{name} = %{version}-%{release}
Requires:	jpackage-utils

%description javadoc
This package contains the API documentation for %{name}.

%prep
%setup -q -n %{name}
%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch3 -p1
%patch4 -p1

# Using the modern jgoodies stuff requires varargs support
sed -i 's/value="1.4"/value="1.5"/' build.xml

sed -i 's/\r//' %{_builddir}/%{name}/accessories/LICENSE.MIT

# set default lookandfeel to be gtk. Fixes bug #729487
sed -i 's/lookandfeel = default/lookandfeel = gtk+/' \
        freemind.properties


find -name '*.class' -exec rm -f '{}' \;
find -name '*.jar' -exec rm -f '{}' \;
find -name '*.zip' -exec rm -f '{}' \;

# linking the libraries needed to build
cd %{_builddir}/freemind/lib
build-jar-repository -s -p . junit jgoodies-forms commons-lang jarbundler

mv commons-lang.jar commons-lang-2.0.jar
mv jarbundler.jar jarbundler-2.0.0.jar
mv jgoodies-forms.jar forms-1.0.5.jar

build-jar-repository -p -s SimplyHTML gnu-regexp-1.1.4 SimplyHTML/SimplyHTML
mv SimplyHTML/SimplyHTML_SimplyHTML.jar SimplyHTML/SimplyHTML.jar

build-jar-repository -p -s jibx bcel commons-logging log4j xpp3 jibx jaxme/jaxmejs
mv jibx/commons-logging.jar jibx/commons-logging-1.0.4.jar
mv jibx/jaxme_jaxmejs.jar jibx/jaxme-js-0.3.jar
mv jibx/log4j.jar jibx/log4j-1.2.8.jar
mv jibx/jibxbind-1.2.4.jar jibx/jibx-bind.jar
mv jibx/jibxextras-1.2.4.jar jibx/jibx-extras.jar
mv jibx/jibxrun-1.2.4.jar jibx/jibx-run.jar

#add all jars for building the svg plugin
cd %{_builddir}/freemind/plugins/svg
build-jar-repository -p -s . batik/batik-awt-util batik/batik-bridge \
 batik/batik-css batik/batik-dom batik/batik-extension batik/batik-ext\
 batik/batik-gui-util batik/batik-gvt batik/batik-parser \
 batik/batik-script batik-squiggle batik/batik-svg-dom \
 batik/batik-svggen batik/batik-swing batik/batik-transcoder \
 batik/batik-util batik/batik-xml js.jar xerces-j2 \
 xml-commons-apis-1.4.01 pdf-transcoder avalon-framework \
 avalon-framework-api avalon-framework-impl
  
#remove the batik_ prefix
for file in batik_*; do mv "$file" "${file/batik_/}"; done
mv xerces-j2.jar xerces_2_5_0.jar
mv xml-commons-apis-1.4.01.jar xml-apis.jar

#add the javahelp.jar for building the help plugin
cd %{_builddir}/freemind/plugins/help
build-jar-repository -p -s . javahelp2
mv javahelp2.jar jhall.jar

cd %{_builddir}/freemind/plugins/script
build-jar-repository -p -s . groovy
mv groovy.jar groovy-all-1.5.6.jar

%build
ant dist all doc 

%install

# jars
mkdir -p %{buildroot}%{_javadir}/%{name}
cp -a %{_builddir}/bin/dist/lib/freemind.jar %{buildroot}%{_javadir}/%{name}/%{name}.jar
cp -a %{_builddir}/bin/dist/lib/bindings.jar %{buildroot}%{_javadir}/%{name}/%{name}-bindings.jar
cp  -a %{_builddir}/bin/dist/browser/freemindbrowser.jar %{buildroot}%{_javadir}/%{name}/%{name}browser.jar


# javadoc
mkdir -p %{buildroot}%{_javadocdir}/%{name}
mv %{_builddir}/bin/dist/doc/javadoc/* %{buildroot}%{_javadocdir}/%{name}


# launcher in /usr/bin
mkdir -p %{buildroot}%{_bindir}
cp -a %{SOURCE3} %{buildroot}%{_bindir}/%{name}

# data needed to run freemind; replaced all jars with symlinks
mkdir -p %{buildroot}%{_datadir}/%{name}/accessories
cp -a %{_builddir}/bin/dist/accessories %{buildroot}%{_datadir}/%{name}

mkdir -p %{buildroot}%{_datadir}/%{name}/doc
cp -a %{_builddir}/bin/dist/doc %{buildroot}%{_datadir}/%{name}
cp -a %{_builddir}/bin/dist/patterns.xml %{buildroot}%{_datadir}/%{name}

mkdir -p %{buildroot}%{_datadir}/%{name}/browser
cp -a %{_builddir}/bin/dist/browser %{buildroot}%{_datadir}/%{name}
rm -f %{buildroot}%{_datadir}/%{name}/browser/freemindbrowser.jar
ln -s %{_javadir}/%{name}/freemindbrowser.jar %{buildroot}%{_datadir}/%{name}/browser/freemindbrowser.jar

mkdir -p %{buildroot}%{_datadir}/%{name}/lib
mkdir -p %{buildroot}%{_datadir}/%{name}/plugins/svg
mkdir -p %{buildroot}%{_datadir}/%{name}/plugins/help
mkdir -p %{buildroot}%{_datadir}/%{name}/plugins/script

cp -a %{_builddir}/bin/dist/plugins/*.xml %{buildroot}%{_datadir}/%{name}/plugins
cp -a %{_builddir}/%{name}/plugins/svg/*.jar %{buildroot}%{_datadir}/%{name}/plugins/svg
cp -a %{_builddir}/bin/dist/plugins/svg/svg_plugin.jar %{buildroot}%{_datadir}/%{name}/plugins/svg
cp -a %{_builddir}/%{name}/plugins/help/jhall.jar  %{buildroot}%{_datadir}/%{name}/plugins/help
cp -a %{_builddir}/bin/dist/plugins/help/help_plugin.jar %{buildroot}%{_datadir}/%{name}/plugins/help
cp -a %{_builddir}/%{name}/plugins/script/groovy-all-1.5.6.jar %{buildroot}%{_datadir}/%{name}/plugins/script
cp -a %{_builddir}/bin/dist/plugins/script/scripting_plugin.jar %{buildroot}%{_datadir}/%{name}/plugins/script
cp -a %{_builddir}/%{name}/lib %{buildroot}%{_datadir}/%{name}


desktop-file-install --dir %{buildroot}%{_datadir}/applications %{SOURCE1}


mkdir -p %{buildroot}%{_datadir}/pixmaps
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/16x16/apps
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/32x32/apps
mkdir -p %{buildroot}%{_datadir}/icons/hicolor/48x48/apps

%{_bindir}/convert -scale 32 %{_builddir}/%{name}/images/FreeMindWindowIcon.png \
%{buildroot}%{_datadir}/pixmaps/%{name}.png

for i in 16 32 48
do
   %{_bindir}/convert -scale $i %{_builddir}/%{name}/images/FreeMindWindowIcon.png %{buildroot}%{_datadir}/icons/hicolor/${i}x${i}/apps/%{name}.png
done

mkdir -p %{buildroot}%{_datadir}/mime/packages
cp -a %{SOURCE2} %{buildroot}%{_datadir}/mime/packages/

#remove the files of the latex plugin
rm -f %{buildroot}%{_datadir}/%{name}/plugins/Latex.xml
rm -rf %{buildroot}%{_datadir}/%{name}/plugins/latex
rm -rf %{buildroot}%{_datadir}/%{name}/doc/javadoc



%post
update-desktop-database &> /dev/null || :
update-mime-database %{_datadir}/mime &> /dev/null || :
touch --no-create %{_datadir}/icons/hicolor &>/dev/null || :

%postun
update-desktop-database &> /dev/null || :
update-mime-database %{_datadir}/mime &> /dev/null || :
if [ $1 -eq 0 ] ; then
    touch --no-create %{_datadir}/icons/hicolor &>/dev/null
    gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :
fi

%posttrans
gtk-update-icon-cache %{_datadir}/icons/hicolor &>/dev/null || :


%files
%defattr(-,root,root,-)
%{_datadir}/applications/*%{name}.desktop
%{_datadir}/mime/packages/%{name}.xml
%{_datadir}/pixmaps/%{name}.png
%{_datadir}/icons/hicolor/16x16/apps/%{name}.png
%{_datadir}/icons/hicolor/32x32/apps/%{name}.png
%{_datadir}/icons/hicolor/48x48/apps/%{name}.png
%{_javadir}/%{name}
%{_datadir}/%{name}
%attr(755,root,root) %{_bindir}/%{name}

%doc history.txt license readme.txt accessories/LICENSE.MIT

%files javadoc
%defattr(-,root,root,-)
%{_javadocdir}/%{name}



%changelog
* Fri Jan 25 2013 Mary Ellen Foster <mefoster@gmail.com> 0.9.0-13
- Update to JGoodies Forms 1.6.0 API

* Thu Dec 27 2012 Johannes Lips <hannes@fedoraproject.org> 0.9.0-12
- fixed the freemind.xml to fix bug #890360

* Thu Jul 19 2012 Fedora Release Engineering <rel-eng@lists.fedoraproject.org> - 0.9.0-11
- Rebuilt for https://fedoraproject.org/wiki/Fedora_18_Mass_Rebuild

* Sun May 06 2012 Johannes Lips <hannes@fedoraproject.org> 0.9.0-10
- bumped the jibx version in the spec due to jibx update 

* Fri Mar 30 2012 Johannes Lips <hannes@fedoraproject.org> 0.9.0-9
- fixed the startup script to find all necessary files
- fixes bug #800769 

* Sun Jan 01 2012 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-8
- jgoodies build patch
- adjusted the freemind.sh to reflect those changes
 
* Wed Aug 31 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-7
- bump release 

* Tue Aug 23 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-6
- added a patch to fix the javadoc build

* Tue Aug 23 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-5
- Fix bug #729487 by setting gtk+ lookandfeel by default

* Thu Jul 07 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-4
- added the avalon-framework-*.jars to the classpath freemind.sh


* Thu Jul 06 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-3
- updated freemind.sh to reflect the version change of jibx
- added additional jar files to freemind.sh
- fixed the wrong directory of the scripting plugin

* Thu Jun 23 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-2
- updated the version of the jibx jar files
- updated the svg build patch to reflect the changes to the avalon-framework

* Tue Feb 15 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-1
- update to recent stable upstream version
- removed the firefox requirement

* Thu Jan 27 2011 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.10.rc15
- update to recent upstream version

* Fri Dec 24 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.9.rc14
- update to recent upstream version

* Wed Dec 22 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.9.rc13
- update to recent upstream version

* Wed Dec 16 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.8.rc12
- update to recent upstream version

* Wed Nov 26 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.7.rc11
- update to recent upstream version

* Wed Nov 26 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.6.rc10
- added java as a build requirement
- changed the build-jar-repository process for jibx

* Wed Nov 26 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.5.rc10
- added jibx as a requirement
- fixed the MIT license file
- minor formatting changes
- fixed the permissions of the sh file

* Wed Nov 19 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.4.rc10
- removed the %%clean section
- removed unnecessary files in /usr/share/freemind
- removed the versioned javadoc directory
- replaced all jar files in /usr/share/freemind with symlinks
- added the LICENSE.MIT
- added a patch to remove the classpath in the manifest file

* Wed Nov 19 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.3.rc10
- added a patch to include avalon-framework into the classpath for the svg plugin
- implemented a for loop for converting the icon files

* Wed Nov 17 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.2.rc10
- removed the classpath patches and used build-jar-repository instead
- consistent usage of %%{buildroot}
- added ws-jaxme and log4j as build requirements
- renamed all the jakarta packages
- changed the group

* Wed Sep 29 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0-0.1.rc10
- update to recent upstream release candidate version
- removed the latex plugin which depends on HotEqn
- dropped the BuildRequires and Requires of HotEqn
- added a patch to build the svg plugin properly
- changed the version scheme
- added hicolor-icon-theme as a requirement
- added the %%post and %%postun section and added entries for mime-info, icon and desktop file

* Wed Sep 29 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0.rc9-3
- added a freemind directory for all freemind jars

* Sat Sep 25 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0.rc9-2
- changed the path to jar-files in freemind.sh 

* Sat Sep 16 2010 Johannes Lips <Johannes.Lips googlemail com> 0.9.0.rc9-1
- initial fedora spec 

